//
AsyncWebSocket wsStatus("/wss");

int wsSConnected(void)
{

  return wsStatus.count();
}

void wsSSend(String &txt)
{

  wsStatus.textAll(txt); // odesleme informace do klienta
}

// Osetreni komunikace pres webovy soket
void wseStatus(AsyncWebSocket * server, AsyncWebSocketClient * client, AwsEventType type, void * arg, uint8_t *data, size_t len)
{

  switch (type)
  {
    case WS_EVT_DISCONNECT:
      break;

    case WS_EVT_CONNECT:
      { // zalogovani pripojeni prohlizece

// odesilame prvni informace do klienta
        String inf;

        inf.reserve(512);
        inf = F("{\"type\":\"hwinfo\"");
        inf.concat(F(",\"version\":\""));
        inf.concat(F(VERSION));
        inf.concat(F("\""));
        inf.concat(F("}"));

        trace_forceupdate(); // vynutime take odeslani informaci ze stopare po pripojeni
        client->text(inf); // odesleme informace do klienta
      }
    break;

    case WS_EVT_DATA:
      {
        int free = ESP.getFreeHeap();
        AwsFrameInfo *info = (AwsFrameInfo *)arg;

        if (WS_TEXT == info->opcode)
        {
          if (!strncmp_P((const char *)data, PSTR("status"), info->len))
          {
            String inf;

            inf.reserve(512);
            inf = F("{\"type\":\"status\",\"ram\":");
            int load = 0;

            if (upcounter > 0)
              load = 100 - (100 * loopCounterLast / loopCounterMax);
            inf.concat(free);
            inf.concat(F(",\"load\":"));
            inf.concat(load);
            inf.concat(F(",\"lc\":"));
            inf.concat(loopCounterLast);
            inf.concat(F("}"));
            client->text(inf);
          }

          if (!strncmp_P((const char *)data, PSTR("wscan"), info->len))
          { // ziskani seznamu WiFi siti v dosahu
            TRACE(TRACE_INFO, F("Request WiFi scan"));
            String json;

            json.reserve(2048);
            json = F("[");
            int n = WiFi.scanComplete();

            if (n == -2)
            {
              WiFi.scanNetworks(true);
            } else if (n)
            {
              for (int i = 0; i < n; ++i)
              {
                if (i)
                  json.concat(F(","));
                json.concat(F("{"));
                json.concat(F("\"rssi\":"));
                json.concat(String(WiFi.RSSI(i)));
                json.concat(F(",\"ssid\":\""));
                json.concat(WiFi.SSID(i));
                json.concat(F("\",\"bssid\":\""));
                json.concat(WiFi.BSSIDstr(i));
                json.concat(F("\",\"channel\":"));
                json.concat(String(WiFi.channel(i)));
                json.concat(F(",\"secure\":"));
                json.concat(String(WiFi.encryptionType(i)));
                json.concat(F(",\"hidden\":"));
                json.concat(String(WiFi.isHidden(i)?F("true"):F("false")));
                json.concat(F("}"));
              }
              WiFi.scanDelete();
              if (WiFi.scanComplete() == -2)
              {
                WiFi.scanNetworks(true);
              }
            }
            json.concat(F("]"));
            client->text(json);
          }
        }
      }
    break;

  default:
    break;
  }
}

void init_websocket(void)
{

  wsStatus.onEvent(wseStatus);
  www.addHandler(&wsStatus);
  TRACE_ADDWEB(&wsStatus);
}
